
#include <iostream.h>
#include <math.h>
#include <time.h>

#include "basicwin.h"
#include "process.h"

/* #include </usr/X11R6/include/X11/bitmaps/boxes>
#include </usr/X11R6/include/X11/bitmaps/blank.xbm> */

#include "boxes"
#include "blank.xbm"
#define TITLE_GAP 9

/* Creating window */
xtc_window::xtc_window(int _argc, char *_argv[], Display *_display, Window _mainw,
    int _display_x, int _display_y, 
    unsigned int _display_width, unsigned int _display_height,
    unsigned int _display_border_width, unsigned int _depth,
    XFontStruct *_font_info_first, 
    XFontStruct *_font_info_second, 
    XFontStruct *_font_info_third,
    int _screen_num, int xposi, int yposi, int steps, char _at,
    XEvent *_report, sub_menu_struct *_menu)
{
  border_width = 0;
  window_size  = 0;
  x = xposi;
  y = yposi;
  raise_steps = steps;
  at = _at;
  argc = _argc;
  argv = _argv;
  display = _display;
  mainw = _mainw;
  display_x = _display_x;
  display_y = _display_y;
  display_width = _display_width;
  display_height = _display_height;
  display_border_width = _display_border_width;
  depth = _depth;
  font_info_first  = _font_info_first;
  font_info_second = _font_info_second;
  font_info_third  = _font_info_third;
  screen_num = _screen_num;
  report = _report;
  menu = _menu;
  window_name  = strdup("X-window Task Cards");
  icon_name    = strdup("XTC");
  
  inside_window=0;
  inside_button=0;
  window_raised=0;
  check_button=0;
  do_leave=0;
  
  button_not_drawn=True;
  button = first_button;
  first_button = new menubutton();
  
  Set_properties();
  Create_window();
  Set_graphics_context();
  Set_cursor(argc, argv);
  XMapWindow(display, window);
}

void xtc_window::Create_window()
{
  window=XCreateSimpleWindow(display, mainw, 
          x, y, width, height, border_width, 
          BlackPixel(display,screen_num),
          WhitePixel(display,screen_num));
}

void xtc_window::Set_properties()
{
  if (XStringListToTextProperty(&window_name, 1, &windowName) == 0)
  {
    cout << "Windowname failed\n";
    exit (-1);
  }
  if (XStringListToTextProperty(&icon_name, 1, &iconName) == 0)
  {
    cout << "Windowname failed\n";
    exit (-1);
  }
  if (!(size_hints = XAllocSizeHints()))
  {
     cout << "Couldn't allocate size hints\n";
     exit (-1);
  }
  if (!(wm_hints = XAllocWMHints()))
  {
     cout << "Couldn't allocate size hints\n";
     exit (-1);
  }
  if (!(class_hints = XAllocClassHint()))
  {
     cout << "Couldn't allocate size hints\n";
     exit (-1);
  }

  // check window size
  int textwidth;
  if (at!='L' && at!='R')
    textwidth=XTextWidth(font_info_first, menu->text, strlen(menu->text));  
  width=textwidth;
  height=90;
  draw_window(0);

  switch (at)
  {
    case 'L':
      break;
    case 'R':
      break;
    case 'T':
      //raise_steps=5;
      raise_width=-((height-60)/raise_steps);
      pick_steps=2;
      pick_width=-4;
      
      y=y+23-height;
      break;
    default:
      //raise_steps=5;
      raise_width=((height-50)/raise_steps);
      pick_steps=2;
      pick_width=4;
      
      y=display_height-24-y;
      break;
  }
      
  int wwidth;
  if (textwidth+(2*TITLE_GAP)>width)
  {
    wwidth=width;
    width=((textwidth+(2*TITLE_GAP)+7)/8)*8;
  }
  else
  {
    wwidth=width;
    width=((width+7)/8)*8;
  }
  backg_bmp=new char[(width/8)*height];
  for (int i=0; i<(width/8)*height; i++)
    backg_bmp[i]=char(0xff);

  title_x=x;
  title_x_end=title_x+textwidth+2*TITLE_GAP;
  
  x+=(textwidth/2)+TITLE_GAP-(width/2);
  if (x<0) x=0;
  if (x+wwidth>display_width)
    x=display_width-wwidth;
  title_x-=x;

  // black out background
  char c, d;
  switch ((int) fmod(title_x+textwidth+(2*TITLE_GAP), 8))
  {
    case 7: d=char(0xff); break;
    case 6: d=char(0x7f); break;
    case 5: d=char(0x3f); break;
    case 4: d=char(0x1f); break;
    case 3: d=char(0x0f); break;
    case 2: d=char(0x07); break;
    case 1: d=char(0x03); break;
    case 0: d=char(0x01); break;
    default: d=char(0xff);
  }
  switch ((int) fmod(title_x, 8))
  {
    case 0: c=char(0xff); break;
    case 1: c=char(0xfe); break;
    case 2: c=char(0xfc); break;
    case 3: c=char(0xf8); break;
    case 4: c=char(0xf0); break;
    case 5: c=char(0xe0); break;
    case 6: c=char(0xc0); break;
    case 7: c=char(0x80); break;
    default: c=char(0xff);
  }
  
  // Produce a label and window background
  switch (at)
  {
    case 'T':
    for (int i=height*(width/8); i>height*(width/8) - (width/8)*32; i-=(width/8))
    {
      for (int j=0; j<title_x/8; j++)
        backg_bmp[i+j]=char(0x00);
      backg_bmp[i+(title_x/8)]=c;
      for (int j=(title_x+textwidth+(2*TITLE_GAP))/8+1; j<(width)/8; j++)
        if (i+j<(width/8)*height)  /* -secure- check */
          backg_bmp[i+j]=char(0x00);
      backg_bmp[i+(title_x+textwidth+(2*TITLE_GAP))/8]=d;
    }
    break;
  
    default:
    for (int i=0; i<(width/8)*32; i+=(width/8))
    {
      for (int j=0; j<title_x/8; j++)
        backg_bmp[i+j]=char(0x00);
      backg_bmp[i+(title_x/8)]=c;
      for (int j=(title_x+textwidth+(2*TITLE_GAP))/8+1; j<(width)/8; j++)
        backg_bmp[i+j]=char(0x00);
      backg_bmp[i+(title_x+textwidth+(2*TITLE_GAP))/8]=d;
    }
    break;
  }
}

void xtc_window::Set_graphics_context()
{
  gcvalues.foreground = BlackPixel(display,screen_num);
  gcvalues.background = WhitePixel(display,screen_num);
  gcvaluemask = GCForeground | GCBackground;
  gc = XCreateGC(display, window, gcvaluemask, &gcvalues);
  icon_pixmap =
    XCreatePixmapFromBitmapData(display, window, boxes_bits,
				boxes_height, boxes_width,
				BlackPixel(display, screen_num),
				WhitePixel(display, screen_num),
				depth);

  shape_pixmap = XCreateBitmapFromData(display, window, backg_bmp, width, height);
  static char gray_bits[] = {0x44, 0x44, 0x11, 0x11, 0x44, 0x44, 0x11, 0x11};
  graypixmap = 
    XCreatePixmapFromBitmapData(display, window, gray_bits,
				8, 8,
				BlackPixel(display, screen_num),
				WhitePixel(display, screen_num),
				depth);
  XShapeCombineMask(display, window, ShapeBounding, 0, 0, shape_pixmap, ShapeSet);

  size_hints->flags = PPosition | PSize | PMinSize;
  size_hints->min_width = 1;
  size_hints->min_height = 1;
  wm_hints->initial_state = NormalState;
  wm_hints->input = True;
  wm_hints->icon_pixmap = icon_pixmap;
  wm_hints->flags = StateHint | IconPixmapHint | InputHint;
  class_hints->res_name = "XTC";
  class_hints->res_class = "XTC";
}

void xtc_window::Set_cursor(int argc, char *argv[])
{

  cursor = XCreateFontCursor(display, XC_hand2);
  //setwinattr.background_pixmap = icon_pixmap ;// icon_pixmap; // optional
  setwinattr.override_redirect = True;
  setwinattr.cursor = cursor;
  valuemask =  /*CWBackPixmap |*/ CWOverrideRedirect | CWCursor ;
  XChangeWindowAttributes(display, window, valuemask, &setwinattr);
  XSetWMProperties(display, window, &windowName, &iconName, argv, argc, size_hints, wm_hints, class_hints);
  
  // Set cursor's behaviour
  XSelectInput(display, window, ExposureMask | KeyPressMask | 
      ButtonPressMask | ButtonReleaseMask | StructureNotifyMask | 
      EnterWindowMask | LeaveWindowMask );

  // now used for button mask
  valuemask = CWBackPixel | CWBorderPixel;
}

void xtc_window::check_buttons()
{
  switch(report->type)
  {
    case Expose:
      if (report->xexpose.count != 0)
        break;
      inactivate_button();
      break;

    case ButtonPress:
      break;
      
    case ButtonRelease:
      unpress_button();
      break;
      
    case EnterNotify:
      inside_button=1;
      activate_button();
      break;
    case LeaveNotify:
      inside_button=0;
      inactivate_button();
      begin = clock();
      break;
      
      default:
        break;
  }
}
        
void xtc_window::cycle_buttons()
{
  button = first_button;
  while(button->next!=NULL)
  {
    if (
      XCheckWindowEvent(display, (Window)button->window, 
        ExposureMask | KeyPressMask | 
        ButtonPressMask | ButtonReleaseMask | StructureNotifyMask | 
        EnterWindowMask | LeaveWindowMask, report) != False)
    if (check_button)
      check_buttons();
    button=button->next; 
  }
}

/* Notify procedures */
int xtc_window::check_notifiers()
{
  cycle_buttons();
  if (
  XCheckWindowEvent(display, window, ExposureMask | KeyPressMask | 
      ButtonPressMask | ButtonReleaseMask | StructureNotifyMask | 
      EnterWindowMask | LeaveWindowMask, report) != False)
    switch(report->type)
    {
      case Expose:
        if (report->xexpose.count != 0)
          break;
        draw_window(1);
        break;
      
      case ConfigureNotify:        
        break;
      
      case VisibilityNotify:
        break;
        
      case EnterNotify:
  	XRaiseWindow(display,window);
        inside_window=1;
        if (do_leave==0)
          Pick_window();
        do_leave=0;
        break;
   
      case LeaveNotify:
        begin = clock();
        do_leave=1;
        inside_window=0;
        break;
       
      case ButtonPress:
        break;
      
      case ButtonRelease:
  	XRaiseWindow(display,window);
        Raise_lower_window();
        break;
  
      default:
        break;
      }
      
  end = clock();
  if ((do_leave && ((double)(end-begin)*2)/(CLOCKS_PER_SEC)>1)
     ||
     (inside_window==0 && window_raised==1 && do_leave)
     )
  {
    Unpick_window();
    do_leave=0;
  }
  return do_leave;
}

int xtc_window::type_focus()
{
  return report->xfocus.type;
}

// Moving window
void xtc_window::window_down()
{
  if (window_raised!=2)
    return;

  y+=(height-40)-((height-40)/raise_steps)*raise_steps;
  for (int i=0; i<raise_steps ; i++)
  {
    y+=raise_width;
    XMoveWindow(display, window, x, y);
  }
  check_button=0;
}

void xtc_window::window_up()   
{
  y-=(height-40)-((height-40)/raise_steps)*raise_steps;
  for (int i=0; i<raise_steps; i++)
  {
    y-=raise_width;
    XMoveWindow(display, window, x, y);
  }
  check_button=1;
}

/* Actions */
void xtc_window::Pick_window()
{
  if (window_raised!=0)
    return;
    
  for (int i=0; i<pick_steps; i++)
  {
    y-=pick_width;
    XMoveWindow(display, window, x, y);
  }
  window_raised=1;
}
  
void xtc_window::Unpick_window()
{  
  if (inside_button==1 || window_raised==0)
    return;

  for (int i=0; i<pick_steps; i++)
  {
    y+=pick_width;
    XMoveWindow(display, window, x, y);
  }
  window_down();    
  window_raised=0;
  inside_window=0;
}

void xtc_window::Raise_lower_window()
{
  if (window_raised==2)
  {
    window_down();    
    window_raised=1;
    return;
  }
  window_up();    
  window_raised=2;
}
  
void xtc_window::draw_button()
{
  int textwidth;
  int len=strlen(button->label);

  XClearWindow(display, button->window);
  /* if (button->type==F_EXEC) */
    XSetFont(display, gc, font_info_third->fid);
  /*else
   XSetFont(display, gc, font_info_second->fid);*/
  
  XDrawString(display, button->window, gc, 4, 12, button->label, len);
}

void xtc_window::activate_button()
{
  if (button->type!=F_EXEC)
    return;
  
  setwinattr.background_pixel =  BlackPixel(display,screen_num);
  setwinattr.border_pixel     =  WhitePixel(display,screen_num);

  XChangeWindowAttributes(display, button->window, valuemask, &setwinattr);
  XSetForeground(display, gc, WhitePixel(display,screen_num));
  
  draw_button();
}

void xtc_window::inactivate_button()
{

  if (button->type!=F_EXEC)
  {
    unsigned long _valuemask = CWBackPixmap | CWBorderPixel; 
    XSetWindowAttributes _setwinattr;
    _setwinattr.background_pixmap = graypixmap;
    _setwinattr.border_pixel =  BlackPixel(display,screen_num);
    XChangeWindowAttributes(display, button->window, _valuemask, &_setwinattr);
  }
  else
  {
    setwinattr.background_pixel =  WhitePixel(display,screen_num);
    setwinattr.border_pixel     =  BlackPixel(display,screen_num);
    XChangeWindowAttributes(display, button->window, valuemask, &setwinattr);
    XSetForeground(display, gc, BlackPixel(display,screen_num));
  }
  
  draw_button();
}

void xtc_window::unpress_button()
{
  switch (button->type)
  {
    case F_EXEC:
      exec_function(button->data);
      break;
    case F_RESTART:
      //restart_function(button->data, (int *)display, (int)mainw, argc, argv);
      break;
  }

  window_down();    
  window_raised=1;
  inside_button=0;
}

void xtc_window::init_buttons(GC gc, 
    int xpos, int ypos, int *row_width, char *string, char *data, int do_paint, int type)
{
  int len = strlen(string);
  int textwidth = XTextWidth(font_info_third, string, len);
  if (do_paint)
    XSetFont(display, gc, font_info_third->fid);

  if (textwidth+xpos+8>*row_width)
    *row_width=textwidth+xpos+8;

  if (button_not_drawn && do_paint)
  {

    button->window = XCreateSimpleWindow(display, window, 
        xpos, ypos-14,
        textwidth+8, 16, 1,
        BlackPixel(display,screen_num),
        WhitePixel(display,screen_num));
    XSelectInput(display, button->window, ExposureMask | 
        ButtonPressMask | ButtonReleaseMask | StructureNotifyMask | 
        EnterWindowMask | LeaveWindowMask );
      
    XMapWindow(display, button->window);

    
    button->setlabel(string);
    button->setproc(data);
    button->settype(type);
    button->next = new menubutton();
    button = button->next;
  }
}

/* Painting window */
void xtc_window::draw_submenu(sub_menu_struct *menu, int xpos, int *ypos, int *row_width, int do_paint)
{
  int len, textwidth;
  sub_menu_struct *sub_menu=(sub_menu_struct *)menu->child->child;

  while((sub_menu=sub_menu->next)!=NULL)
  {
    if (sub_menu->type==F_POPUP)
    {
      if (button_not_drawn==True && do_paint)
        sub_menu->create_icon(display, window);

  // get color gc !!
  /*if(sub_menu->icon!=NULL)
	  XCopyPlane(display,sub_menu->icon->icon,sub_menu->icon->width,
		     gc,0,0,sub_menu->icon->width,sub_menu->icon->height,
		     xpos, *ypos, 1);
  // von dem Typs auf fvwm.h...
  Pixel fore;
  Pixel back;*/

    
    /*{
       if(mi->icon && *mi->icon != 0)
	y = y_offset + mi->y_height - mi->icon->height-1;
      else 
	y = y_offset + mi->y_height/2 - mi->icon->height/2;
      if(mi->icon->depth > 0) /* pixmap? *
	{
	  Globalgcm = GCClipMask | GCClipXOrigin | GCClipYOrigin;
	  Globalgcv.clip_mask = mi->icon->mask;
	  Globalgcv.clip_x_origin= 5;
	  Globalgcv.clip_y_origin = y;

	  XChangeGC(display,ReliefGC,Globalgcm,&Globalgcv);
	  XCopyArea(display,mi->icon->picture,mr->w,ReliefGC,0,0,
		    mi->icon->width, mi->icon->height,5,y);
	  Globalgcm = GCClipMask;
	  Globalgcv.clip_mask = None;
	  XChangeGC(display,ReliefGC,Globalgcm,&Globalgcv);
	}
      else
	{
	  XCopyPlane(display,mi->icon->picture,mr->w,
		     TextGC,0,0,mi->icon->width,mi->icon->height,
		     5,y,1);
	}
    }*/
    
      len=strlen(sub_menu->text);
      textwidth=XTextWidth(font_info_second, sub_menu->text, len);
      if (do_paint)
      {
        XSetFont(display, gc, font_info_second->fid);
        XDrawString(display, window, gc, xpos, *ypos, sub_menu->text, len);
      }
      if (textwidth+xpos>*row_width)
      *row_width=textwidth+xpos;
      (*ypos)+=20;
      
      draw_submenu(sub_menu, xpos+14, &(*ypos), &(*row_width), do_paint);
    }
    else
    if (sub_menu->type!=F_NOP)
    {
      init_buttons(gc, xpos, *ypos, &(*row_width), sub_menu->text, sub_menu->function, do_paint, sub_menu->type);
      *ypos+=20;
    }
    else
      *ypos+=8;
  }
  *ypos+=8;
}
  
void xtc_window::draw_window(int do_paint)
{
    
  int len=strlen(menu->text);
  
  int textwidth;
  switch (at)
  {
    case 'L':
      break;
      
    case 'R':
      break;
      
    case 'T':
      textwidth=XTextWidth(font_info_first, menu->text, len);  
      if (do_paint)
      {
 
        XSetFont(display, gc, font_info_first->fid);
        XDrawString(display, window, gc, title_x+TITLE_GAP, height-8, menu->text, len);
        
        // Paint left and top border
        XSetForeground(display, gc, BlackPixel(display,screen_num));
        XDrawLine(display, window, gc, 0, height-32, 1024, height-32);
        XDrawLine(display, window, gc, 0, height-33, 1024, height-33);
        XSetForeground(display, gc, WhitePixel(display,screen_num));
        XDrawLine(display, window, gc, 1, height-34, 1024, height-34);
        XSetForeground(display, gc, BlackPixel(display,screen_num));
        XDrawLine(display, window, gc, 2, height-35, 1024, height-35);
      
        XDrawLine(display, window, gc, 0, height-33, 0, 0);
        XSetForeground(display, gc, WhitePixel(display,screen_num));
        XDrawLine(display, window, gc, 1, height-34, 1, 0);
        XSetForeground(display, gc, BlackPixel(display,screen_num));
        XDrawLine(display, window, gc, 2, height-35, 2, 0);

        // Paint title's border
        XDrawLine(display, window, gc, title_x, height-1, title_x+textwidth+(2*TITLE_GAP), height-1);
        //XDrawLine(display, window, gc, title_x, height-2, title_x+textwidth+(2*TITLE_GAP), height-2);
        XDrawLine(display, window, gc, title_x, height-1, title_x, height-34);
        XDrawLine(display, window, gc, title_x+textwidth+(2*TITLE_GAP), height-1, 
                                       title_x+textwidth+(2*TITLE_GAP), height-34);
        XSetForeground(display, gc, WhitePixel(display,screen_num));
        XDrawLine(display, window, gc, title_x+1, height-32, title_x+textwidth+(2*TITLE_GAP)-1, height-32);
        XDrawLine(display, window, gc, title_x+1, height-33, title_x+textwidth+(2*TITLE_GAP)-1, height-33);
        XSetForeground(display, gc, BlackPixel(display,screen_num));
      }
      break;
      
    default:
      textwidth=XTextWidth(font_info_first, menu->text, len);  
      if (do_paint)
      {
        XSetFont(display, gc, font_info_first->fid);
        XDrawString(display, window, gc, title_x+TITLE_GAP, 18, menu->text, len);
        
        // Paint left and top border
        XSetForeground(display, gc, BlackPixel(display,screen_num));
        XDrawLine(display, window, gc, 0, 32, 1024, 32);
        XDrawLine(display, window, gc, 0, 33, 1024, 33);
        XSetForeground(display, gc, WhitePixel(display,screen_num));
        XDrawLine(display, window, gc, 1, 34, 1024, 34);
        XSetForeground(display, gc, BlackPixel(display,screen_num));
        XDrawLine(display, window, gc, 2, 35, 1024, 35);
      
        XDrawLine(display, window, gc, 0, 33, 0, height);
        XSetForeground(display, gc, WhitePixel(display,screen_num));
        XDrawLine(display, window, gc, 1, 34, 1, height);
        XSetForeground(display, gc, BlackPixel(display,screen_num));
        XDrawLine(display, window, gc, 2, 35, 2, height);

        // Paint title's border
        XDrawLine(display, window, gc, title_x, 0, title_x+textwidth+(2*TITLE_GAP), 0);
        XDrawLine(display, window, gc, title_x, 0, title_x, 33);
        XDrawLine(display, window, gc, title_x+textwidth+(2*TITLE_GAP), 0, 
                                       title_x+textwidth+(2*TITLE_GAP), 33);
        XSetForeground(display, gc, WhitePixel(display,screen_num));
        XDrawLine(display, window, gc, title_x+1, 32, title_x+textwidth+(2*TITLE_GAP)-1, 32);
        XDrawLine(display, window, gc, title_x+1, 33, title_x+textwidth+(2*TITLE_GAP)-1, 33);
        XSetForeground(display, gc, BlackPixel(display,screen_num));
      }
      break;
  }

  int xpos=10;
  
  if (menu->child==NULL) return;
  sub_menu_struct *oth_menu=(sub_menu_struct *)menu->child->child;
  
  while((oth_menu=oth_menu->next)!=NULL)
  {
      int ypos=58;
      int row_width=0;
    if (oth_menu->type==F_POPUP)
    {
      len=strlen(oth_menu->text);
      textwidth=XTextWidth(font_info_second, oth_menu->text, len);
      if (do_paint)
      {
        XSetFont(display, gc, font_info_second->fid);
        XDrawString(display, window, gc, xpos, ypos, oth_menu->text, len);
      }
      row_width=textwidth+xpos;
      ypos+=22;
      draw_submenu(oth_menu, xpos+14, &ypos, &row_width, do_paint);
      xpos=row_width+26;
    }
    else
    if (oth_menu->type!=F_NOP)
    {
      init_buttons(gc, xpos, ypos, &row_width, oth_menu->text, oth_menu->function, do_paint, oth_menu->type);
      ypos+=20;
      
      // Don't create rows for no-popups
      while (oth_menu->next!=NULL && oth_menu->type!=F_POPUP &&
             oth_menu->next->type!=F_POPUP)
      {
        oth_menu=oth_menu->next;
        if (oth_menu->type!=F_NOP)
        {
          init_buttons(gc, xpos, ypos, &row_width, oth_menu->text, 
                    oth_menu->function, do_paint, oth_menu->type);
          ypos+=20;
        }
        else
          ypos+=8;
      }
      xpos=row_width+26;
    }
    else
      ypos+=8;
   
    if (oth_menu->type!=F_NOP && do_paint && oth_menu->next!=NULL)
    {
      switch (at)
      {
        case 'L':
          break;
          
        case 'R':
          break;
          
        case 'T':
          XSetForeground(display, gc, BlackPixel(display,screen_num));
          XDrawLine(display, window, gc, xpos-11, height-35, xpos-11, 0);
          XSetForeground(display, gc, WhitePixel(display,screen_num));
          XDrawLine(display, window, gc, xpos-10, height-34, xpos-10, 0);
          XSetForeground(display, gc, BlackPixel(display,screen_num));
          XDrawLine(display, window, gc, xpos-9 , height-35, xpos-9, 0);
          break;
          
        default:
          XSetForeground(display, gc, BlackPixel(display,screen_num));
          XDrawLine(display, window, gc, xpos-11, 35, xpos-11, height);
          XSetForeground(display, gc, WhitePixel(display,screen_num));
          XDrawLine(display, window, gc, xpos-10, 34, xpos-10, height);
          XSetForeground(display, gc, BlackPixel(display,screen_num));
          XDrawLine(display, window, gc, xpos-9 , 35, xpos-9, height);
          break;
      }
    }
    if (ypos+32>height)
      height=ypos+32;
  }
  
  if (do_paint==0)
    width=xpos-7;

  if (do_paint)
  {
    switch (at)
    {
      case 'L':
        break;
        
      case 'R':
        break;
        
      case 'T':
        XSetForeground(display, gc, BlackPixel(display,screen_num));
        XDrawLine(display, window, gc, width-4 , height-35, width-4, 0);
        XSetForeground(display, gc, WhitePixel(display,screen_num));
        XDrawLine(display, window, gc, width-3 , height-34, width-3, 0);
        XSetForeground(display, gc, BlackPixel(display,screen_num));
        XDrawLine(display, window, gc, width-2 , height-33, width-2, 0);
        XDrawLine(display, window, gc, width-1 , height-32, width-1, 0);
        break;
        
      default:
        XDrawLine(display, window, gc, width-4 , 35, width-4, height);
        XSetForeground(display, gc, WhitePixel(display,screen_num));
        XDrawLine(display, window, gc, width-3 , 34, width-3, height);
        XSetForeground(display, gc, BlackPixel(display,screen_num));
        XDrawLine(display, window, gc, width-2 , 33, width-2, height);
        XDrawLine(display, window, gc, width-1 , 32, width-1, height);
        break;
    }
    button_not_drawn=False;
  }
}
